// XMLHttpRequest object
var gReq                = null;

// Flags
var gOpen               = false;
var gImageDisplayed     = false;
var gOverlaysVisible    = false;


var gUrl;
var gItems; // stores list of items returned by AWS

// HTML elements
var gArt                = null;
var gSlide              = null;
var gShowThumbnailsLink = null;
var gItunesLink         = null;

// global variable for o() function
var gObjs               = new Object(); 

var gLocalJpeg          = "amazonart.jpg";

// user preferences
var gCountry            = 'us';
var gCategory           = 'Music';
var gMode               = "selection";

var gDoneButton;
var gInfoButton; 

// Animator class stuff
var gOverlaysFadeAnimator   = null;
var gOverlaysFadeAnimation  = null;

var gSlideOpenAnimator      = new AppleAnimator(400, 50);
var gSlideClosedAnimator    = new AppleAnimator(400, 50);
var gSlideOpenAnimation     = new AppleAnimation(0, 200, slideIt);
var gSlideClosedAnimation   = new AppleAnimation(200, 0, slideIt);

gSlideOpenAnimator.addAnimation(gSlideOpenAnimation);
gSlideClosedAnimator.addAnimation(gSlideClosedAnimation);
gSlideClosedAnimator.oncomplete = slideClosedCompleted;

if (window.widget) 
{
    widget.onhide = onhide;
}

function nullEvent(e)
{
    e.stopPropagation();
}

function onhide()
{
    if (gOverlaysFadeAnimator != null)
        gOverlaysFadeAnimator.stop();
    
    if (gSlideOpenAnimator != null)
        gSlideOpenAnimator.stop();
    
    if (gSlideClosedAnimator != null)
        gSlideClosedAnimator.stop();
}

function setup()
{
    gDoneButton             = new AppleGlassButton(o("doneButton"), getLocalisedString("Done"), hidePrefs);
    gInfoButton             = new AppleInfoButton(o("infoButton"), o("front"), "black", "black", showPrefs);

    gArt                    = o("art");
    gSlide                  = o("slide");
    gItunesLink             = o("add_to_itunes");
    gShowThumbnailsLink     = o("show_thumbnails");
    
    o("version").innerHTML  = "v" + version();

    gShowThumbnailsLink.addEventListener("mouseup", showThumbnails, false);
    gItunesLink.addEventListener("mouseup", setAlbumArt, false);
    
    // do localisation
    gArt.innerHTML                      = '<p>' + getLocalisedString("No artwork requested yet") + '</p>';
    gItunesLink.innerHTML               = '<a href="#" id="add_to_itunes_a">' + getLocalisedString("Set as album art in iTunes") + '</a>';

    o("itunes_icon").setAttribute("title", getLocalisedString("Get album details from iTunes"));
    o("itunes_icon").setAttribute("alt", getLocalisedString("Get album details from iTunes"));

    o("s").setAttribute("placeholder", getLocalisedString("Album details"));

    o("country_label").innerHTML        = getLocalisedString("Preferred Amazon store");
    o("category_label").innerHTML       = getLocalisedString("Search for");
    o("cat_popular").innerHTML          = getLocalisedString("Popular Music");
    o("cat_classical").innerHTML        = getLocalisedString("Classical Music");

    o("proxy_label").innerHTML          = getLocalisedString("Use proxy server");
    o("proxy_addr").setAttribute("placeholder", getLocalisedString("Proxy address"));
    o("proxy_port").setAttribute("placeholder", getLocalisedString("Port"));
    
    o("mode_label").innerHTML           = getLocalisedString("Operate on");
    o("mode_selection").innerHTML       = getLocalisedString("Selected tracks");
    o("mode_playing_track").innerHTML   = getLocalisedString("Currently playing track");
    o("mode_playing_album").innerHTML   = getLocalisedString("Currently playing album");
    
    o("small_images_label").innerHTML   = getLocalisedString("Save small images to iTunes");
    
    if(window.widget)
    {
        // initialise country drop-down
        var countryCode = widget.preferenceForKey("countryCode");
     
        if (countryCode && countryCode.length > 0)
        {
            gCountry = countryCode;
            o("country").value = gCountry;
        }
        
        // initialise category drop-down
        var preferredCategory = widget.preferenceForKey("preferredCategory");
     
        if (preferredCategory && preferredCategory.length > 0)
        {
            gCategory = preferredCategory;
            o("category").value = gCategory;
        }

        // initialise mode drop-down
        var preferredMode = widget.preferenceForKey("preferredMode");
     
        if (preferredMode && preferredMode.length > 0)
        {
            gMode = preferredMode;
            o("mode").value = gMode;
        }

        // initialise proxy settings
        var proxyAddress    = widget.preferenceForKey("proxyAddress");
        var proxyPort       = widget.preferenceForKey("proxyPort");
        var useProxy        = widget.preferenceForKey("useProxy");
        
        if (proxyAddress && proxyAddress.length > 0)
            o("proxy_addr").value = proxyAddress;
        if (proxyPort && proxyPort.length > 0)
            o("proxy_port").value = proxyPort;
        if (useProxy)
            o("use_proxy").checked = useProxy;
        
        // initialise small images option
        var smallImages     = widget.preferenceForKey("smallImages");
        if (smallImages && smallImages.length > 0)
            o("small_images").checked = smallImages;
    }
    toggleUseProxy();
}

// ----- IMAGE SEARCH AND DISPLAY STUFF -----

function doSearch()
{
    hideThumbnails();
    var s = o("s").value;

    var endpoints   = new Array();
    endpoints['uk'] = "ecs.amazonaws.co.uk";
    endpoints['jp'] = "ecs.amazonaws.jp";
    endpoints['us'] = "ecs.amazonaws.com";
    endpoints['ca'] = "ecs.amazonaws.ca";
    endpoints['fr'] = "ecs.amazonaws.fr";
    endpoints['de'] = "ecs.amazonaws.de";
    endpoints['at'] = "ecs.amazonaws.de"; // austria - use .de for AWS access
    
    awsAccessKey = "AKIAJPIZ5OSF75MG6TFA";
    awsSecretKey = "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";

    if (s)
    {
        s = sanitise(s);

        gReq = new XMLHttpRequest();
        gArt.innerHTML = '<img src="images/progress.gif" />';
        
        gReq.onreadystatechange = getItems;

        // Keys must be sorted in A-Z order for signing
        queryString = "AWSAccessKeyId=" + awsAccessKey
                    + "&Keywords=" + encodeURIComponent(s)
                    + "&Operation=ItemSearch"
                    + "&ResponseGroup=Images,Small"
                    + "&SearchIndex=" + gCategory 
                    + "&Service=AWSECommerceService"
                    + "&Timestamp=" + getTimestamp()
                    + "&Version=2009-01-06";
                    
        // URL-encode commas and colons, per
        // http://docs.amazonwebservices.com/AWSECommerceService/latest/DG/index.html?rest-signature.html
        queryString = queryString.replace(/:/g, "%3A");
        queryString = queryString.replace(/,/g, "%2C");
        
        signatureInput = "GET\n" 
                       + endpoints[gCountry] + "\n"
                       + "/onca/xml\n" 
                       + queryString;
                       
        signature = HMAC_SHA256_MAC_B64(awsSecretKey, signatureInput);
        
        // URL-encode plus and equals signs, per AWS docs (see link above)
        signature = signature.replace(/\+/g, "%2B");
        signature = signature.replace(/=/g, "%3D");
        
        reqString = "http://"
                  + endpoints[gCountry] 
                  + "/onca/xml?" 
                  + queryString
                  + "&Signature=" + signature;
        
        gReq.open("GET", reqString);
        gReq.send();

        if (!gOpen)
        {
            slideOpen();
        }
    }
    else if (gOpen)
    {
        slideClosed();
    }
}

function getItems()
{
    if (gReq.readyState == 4)
    {
        if (gReq.status == 200)
        {
            var tempItems = gReq.responseXML.getElementsByTagName("Item");
            gItems = new Array()

            foundValidImage = false;

            for (i = 0; i < tempItems.length; i++)
            {
                if (hasLargeImage(tempItems[i]) || hasMediumImage(tempItems[i]))
                {
                    gItems.push(tempItems[i]);
                    foundValidImage = true;
                }
            }
            if (foundValidImage)
            {
                updateArt(0);
                overlaysFadeIn();
            }
            else
            {
                var s = sanitise(o("s").value);
                var googleimgquery = "javascript:widget.openURL('http://images.google.com/images?q=" + encodeURIComponent(s) +"')";
                gArt.innerHTML = '<p>' + getLocalisedString("No results found.") + '<br /><a href="' + googleimgquery + '">' + getLocalisedString("Why not search Google Images?") + '</a></p>';
                gImageDisplayed = false;
                overlaysFadeOut();
            }
        }
        else {
            gArt.innerHTML = '<p>Error connecting to Amazon</p>';
        }
    }
}

function updateArt(index)
{
    gUrl    = hasLargeImage(gItems[index]) ? largeImage(gItems[index]) : mediumImage(gItems[index]);
    ASIN    = gItems[index].getElementsByTagName("ASIN")[0].firstChild.data;            

    gArt.innerHTML = "<a href=\"#\" onClick=\"goAmazon('" + ASIN + "');\"><img src=\"" + gUrl  + "\" height=\"200\" width=\"200\" border=\"0\" id=\"art_img\"/></a>";
    hideThumbnails();
    gImageDisplayed = true;
    
    if (!gOverlaysVisible) overlaysFadeIn();

    thumbnails = o("thumbnails");
    thumbnails.innerHTML = "";
    for (i = 0; i < gItems.length && i < 10; i++)
    {
        cssclass                = i == index ? "thumbnail selected" : "thumbnail";
        thumburl                = hasSmallImage(gItems[i]) ? smallImage(gItems[i]) : hasMediumImage(gItems[i]) ? mediumImage(gItems[i]) : largeImage(gItems[i]);
        tooltip                 = itemTooltip(gItems[i]);
        thumbnails.innerHTML    = thumbnails.innerHTML + "<a href=\"#\" class=\"" + cssclass + "\"><img src=\"" + thumburl + "\" alt=\"" + tooltip + "\" title=\"" + tooltip + "\" width=\"35\" height=\"35\" onClick=\"updateArt(" + i + ");\"></a>";
    }
}

function hideThumbnails()
{
    o("thumbnails").style.visibility = "hidden";
}

function showThumbnails()
{
    o("thumbnails").style.visibility = "visible";
}

// ----- COPY IMAGE TO ITUNES STUFF -----

function setAlbumArt()
{
    // download image to home folder

    /*
     * curl options:
     * =============
     *
     * -m 30            timeout after 30 seconds
     * -sS              silent (s) except for errors (S)
     * -o FILE          write output to FILE
     * -f               generate an error on HTTP error (e.g. 404), rather than writing error message HTML to output file
     * -x ADDR:PORT     specifies proxy details
     *
     */

    var useProxy    = o("use_proxy").checked;
    var curlCmd     = "curl -m 30 -sSf";
    var cacheDir    = "~/Library/Caches/com.widget-foundry.widget.albumart"
    
    if (useProxy)
    {
        var proxyAddr = o("proxy_addr").value;
        var proxyPort = o("proxy_port").value;
        
        if (proxyAddr.length > 0)
        {
            curlCmd = curlCmd + " -x " + proxyAddr;
            if (proxyPort.length > 0)
            {
                curlCmd = curlCmd + ":" + proxyPort;
            }
        }
    }
    
    curlCmd = curlCmd + " -o " + cacheDir + "/" + gLocalJpeg + " " + gUrl;

    if (window.widget)
    {
        widget.system("mkdir " + cacheDir, null);
        widget.system(curlCmd, processDownloadedImage);
    }
    else
    {
        window.console.log(curlCmd);
    }
    gItunesLink.innerHTML = getLocalisedString("Processing");
}

function processDownloadedImage(currentStringOnStdout)
{
    if (currentStringOnStdout.length > 0)
    {
        // curl only outputs on error - so if there was output, something went wrong
        gItunesLink.innerHTML = getLocalisedString("Select iTunes tracks first");
        setTimeout(resetAddToiTunesImage, 5000);
    }
    else
    {
        if (window.widget)
        {
            var useSmallImages = o("small_images").checked ? "Yes" : "No";
            var output = widget.system("/usr/bin/osascript SetCoverArt.scpt " + gLocalJpeg + " " + gMode + " " + useSmallImages, null).outputString;
            if (output && output.substr(0,6) == "Error:")
            {
                output.match(/Error: (\w+)/);
                var errorcode = RegExp.$1;
                var errortext = "";
                switch(errorcode)
                {
                    case 'itunesnotrunning':
                        errortext = getLocalisedString("iTunes is not running");
                        break;
                    case 'jpegnotfound':
                        errortext = getLocalisedString("Can't download image");
                        break;
                    case 'cantwritetoitunes':
                        errortext = getLocalisedString("iTunes is not running");
                        break;
                    case 'notracks':
                        errortext = getLocalisedString("Select/play tracks in iTunes first");
                        break;
                    case 'convertimagefailed':
                        errortext = getLocalisedString("Can't prepare image for iTunes");
                        break;
                    default:
                        errortext = getLocalisedString("Unknown error");
                }
                gItunesLink.innerHTML = getLocalisedString("Error: ") + errortext;
                setTimeout(resetAddToiTunesImage, 5000);
            }
            else
            {
                resetAddToiTunesImage();
            }
        }
    }
}

function resetAddToiTunesImage()
{
    gItunesLink.innerHTML = '<a href="#" id="add_to_itunes_a">' + getLocalisedString("Set as album art in iTunes") + '</a>';
}

function toggleUseProxy()
{
    if (o("use_proxy").checked)
    {
        o("proxy_settings").style.visibility = "visible";
    }
    else
    {
        o("proxy_settings").style.visibility = "hidden";
    }
    saveProxyPrefs();
}

function saveProxyPrefs()
{
    if (window.widget)
    {
        widget.setPreferenceForKey(o("proxy_addr").value, "proxyAddress");
        widget.setPreferenceForKey(o("proxy_port").value, "proxyPort");
        widget.setPreferenceForKey(o("use_proxy").checked, "useProxy");
    }
}

function saveSmallImagePrefs()
{
    if (window.widget)
    {
        widget.setPreferenceForKey(o("small_images").checked, "smallImages");
    }
}

function fadeOverlays(animation, current, start, finish)
{
    o("add_to_itunes_container").style.opacity  = current;
    gShowThumbnailsLink.style.opacity           = current;
}

function overlaysHideImmediately()
{
    if (gOverlaysFadeAnimator != null)
    {
        gOverlaysFadeAnimator.stop();
        delete gOverlaysFadeAnimation;
        delete gOverlaysFadeAnimator;
    }

    gOverlaysVisible                    = false;
    overlaysFadeOutCompleted();
}

function overlaysFadeOutCompleted()
{
    gItunesLink.style.visibility            = "hidden";
    gShowThumbnailsLink.style.visibility    = "hidden";
}

function overlaysFadeInCompleted()
{
    delete gOverlaysFadeAnimator;
}

function overlaysFadeOut()
{
    gOverlaysVisible                        = false;

    if (gOverlaysFadeAnimator != null)
    {
        gOverlaysFadeAnimator.stop();
        delete gOverlaysFadeAnimation;
        delete gOverlaysFadeAnimator;
    }

    gOverlaysFadeAnimator   = new AppleAnimator(500, 50);
    gOverlaysFadeAnimation  = new AppleAnimation(1.0, 0.0, fadeOverlays);

    gOverlaysFadeAnimator.addAnimation(gOverlaysFadeAnimation);
    gOverlaysFadeAnimator.oncomplete = overlaysFadeOutCompleted;
    gOverlaysFadeAnimator.start();
}

function overlaysFadeIn()
{
    gOverlaysVisible                    = true;
    gItunesLink.style.visibility            = "visible";
    gShowThumbnailsLink.style.visibility    = "visible";

    if (gOverlaysFadeAnimator != null)
    {
        gOverlaysFadeAnimator.stop();
        delete gOverlaysFadeAnimation;
        delete gOverlaysFadeAnimator;
    }
    gOverlaysFadeAnimator   = new AppleAnimator(500, 50);
    gOverlaysFadeAnimation  = new AppleAnimation(0.0, 1.0, fadeOverlays);

    gOverlaysFadeAnimator.addAnimation(gOverlaysFadeAnimation);
    gOverlaysFadeAnimator.oncomplete = overlaysFadeInCompleted;
    gOverlaysFadeAnimator.start();
}

// ----- GET DETAILS OF CURRENT SELECTION FROM ITUNES STUFF -----

function getDetailsFromiTunes()
{
    if (window.widget)
    {
        o("s").value = getLocalisedString("Fetching...");
        var output = widget.system("/usr/bin/osascript GetSelectionDetails.scpt " + gMode, null).outputString;
        if (output && output.length > 0)
        {
            output = output.replace(/\s+$/, ""); // remove white space from end of string - removes LF that Applescript writes
            o("s").value = output;
            doSearch();
        }
        else
        {
            o("s").value = "";
        }
    }
}

// ----- SLIDE STUFF -----

function goAmazon(ASIN)
{
    if (window.widget)
    {
        var aa_url;
        switch (gCountry)
        {
            case 'uk':      
                aa_url = "http://www.amazon.co.uk/exec/obidos/redirect?link_code=ur2&tag=netcetera06-21&camp=1634&creative=6738&path=ASIN%2F" + ASIN + "%2F";
                break;
            case 'ca':
                aa_url = "http://www.amazon.ca/exec/obidos/redirect?link_code=as2&path=ASIN/" + ASIN + "&tag=thewidgetfoun-20&camp=15121&creative=330641";
                break;
            case 'fr':
                aa_url = "http://www.amazon.fr/exec/obidos/redirect?link_code=as2&path=ASIN/" + ASIN + "&tag=thewidgetfoun-21&camp=1642&creative=6746";
                break;
            case 'de':
                aa_url = "http://www.amazon.de/exec/obidos/redirect?link_code=as2&path=ASIN/" + ASIN + "&tag=thewidgetfo05-21&camp=1638&creative=6742";
                break;
            case 'at':
                aa_url = "http://www.amazon.de/exec/obidos/redirect?link_code=as2&path=ASIN/" + ASIN + "%3Fsite-redirect=at&tag=thewidgetfo05-21&camp=1638&creative=6742";
                break;
            case 'jp':
                aa_url = "http://www.amazon.co.jp/exec/obidos/ASIN/" + ASIN;
                break;
            default: // us
                aa_url = "http://www.amazon.com/exec/obidos/redirect?link_code=as2&path=ASIN/" + ASIN + "&tag=chubbybat-20&camp=1789&creative=9325";
        }
        widget.openURL(aa_url);
    }
}


function toggleSlide()
{
    if (gOpen)
    {
        slideClosed();
    }
    else
    {
        slideOpen();
    }
}

function slideOpen()
{
    gSlideOpenAnimator.stop();
    gSlideClosedAnimator.stop();

    gOpen = true;
    if (window.widget)
        window.resizeTo(216, 257);
    gSlideOpenAnimator.start();
}

function slideClosed()
{
    gSlideOpenAnimator.stop();
    gSlideClosedAnimator.stop();

    gSlideClosedAnimator.start();
}

function slideIt(animation, current, start, finish)
{
    gSlide.style.height = current + "px";
    o("fbottom").style.top = current + "px";
}

function slideClosedCompleted()
{
    if (window.widget)
        window.resizeTo(216, 56);
    o("fbottom").style.top = "-1px";
    gOpen = false;
}

// ----- BACK OF WIDGET STUFF -----

function goWebsite()
{
    widget.openURL("http://www.widget-foundry.com/");
}

function goPaypal()
{
    widget.openURL("https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=sw%40netcetera%2eorg&item_name=Amazon%20Album%20Art%20Widget&amount=10%2e00&no_shipping=2&no_note=1&tax=0&currency_code=USD&bn=PP%2dDonationsBF&charset=UTF%2d8");
}

function setCountry()
{
    gCountry = o("country").value;
    if(window.widget)
    {
        widget.setPreferenceForKey(gCountry,"countryCode");
    }
}

function setCategory()
{
    gCategory = o("category").value;
    if(window.widget)
    {
        widget.setPreferenceForKey(gCategory,"preferredCategory");
    }
}

function setMode()
{
    gMode = o("mode").value;
    if(window.widget)
    {
        widget.setPreferenceForKey(gMode,"preferredMode");
    }
}

// ----- STANDARD WIDGET STUFF -----

function showPrefs()
{
    if (window.widget)
        window.resizeTo(216, 257);

    var front = o("front");
    var back = o("back");
 
    if (window.widget)
        widget.prepareForTransition("ToBack");
 
    front.style.display="none";
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs()
{
    var front = o("front");
    var back = o("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    back.style.display="none";
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

// ----- MISC FUNCTIONS -----

function itemTooltip(item)
{
    var artist = item.getElementsByTagName("Artist")[0] ? item.getElementsByTagName("Artist")[0].firstChild.data : "Unknown Artist";
    var title  = item.getElementsByTagName("Title")[0]  ? item.getElementsByTagName("Title")[0].firstChild.data  : "Unknown Title";
    return artist + " - " + title;
}
function largeImage(item)
{
    return item.getElementsByTagName("LargeImage")[0].getElementsByTagName("URL")[0].firstChild.data;
}
function smallImage(item)
{
    return item.getElementsByTagName("SmallImage")[0].getElementsByTagName("URL")[0].firstChild.data;
}
function mediumImage(item)
{
    return item.getElementsByTagName("MediumImage")[0].getElementsByTagName("URL")[0].firstChild.data;
}

function hasLargeImage(item)
{
    return item.getElementsByTagName("LargeImage")[0] != null;
}
function hasMediumImage(item)
{
    return item.getElementsByTagName("MediumImage")[0] != null;
}
function hasSmallImage(item)
{
    return item.getElementsByTagName("SmallImage")[0] != null;
}

function o(x) 
{ 
    if ( !gObjs[x] ) 
        gObjs[x] = document.getElementById(x); 
    return gObjs[x]; 
}

// version function courtesy of Joshua Emmons (www.skia.net)
function version()
{
    var xmlReq  = new XMLHttpRequest();
    xmlReq.open("GET", "Info.plist", false);
    xmlReq.send(null);

    var xml     = xmlReq.responseXML;
    var keys    = xml.getElementsByTagName("key");
    var ver     = "0.0";

    for(i = 0; i < keys.length; i++)
    {
        if("CFBundleVersion" == keys[i].firstChild.data)
        {
            ver = keys[i].nextSibling.nextSibling.firstChild.data;
            break;
        }
    }
    return ver;
}

function sanitise(s)
{
    // render a string suitable for passing as an argument to AWS or Google Images
    s = s.replace(/\[.*?\]/g, "");  // remove stuff in square brackets, like [EP]
//  s = s.replace(/'/g, "");        // remove single quotes
    return s;
}

function getLocalisedString(key)
{
    try 
    {
        var ret = localisedStrings[key];
        if (ret === undefined)
            ret = key;
        return ret;
    }
    catch (ex) 
    {
    }
    return key;
}

function padNum(num, len, padChar) 
{
    sNum = new String(num);
    if (padChar.length == 1) 
    {
        while (sNum.length < len)
            sNum = padChar + sNum;
    }
    return sNum;
}

function getTimestamp()
{
    var d = new Date();
    
    var result = d.getUTCFullYear() + "-"
               + padNum(d.getUTCMonth() + 1, 2, "0") + "-"
               + padNum(d.getUTCDate(), 2, "0") + "T"
               + padNum(d.getUTCHours(), 2, "0") + ":"
               + padNum(d.getUTCMinutes(), 2, "0") + ":"
               + padNum(d.getUTCSeconds(), 2, "0") + "Z";

    return result;
}